using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using Example1Library.DataSet1TableAdapters;

namespace Example1Library
{
	public class NotFoundException : Exception
	{
		public NotFoundException(string message) : base(message) { }
	}

	public static class MultiplicationTables
	{
		/// <summary>
		/// Retrieve a value from the multiplication table in the database.
		/// </summary>
		/// <param name="number1">A number to multiply.</param>
		/// <param name="number2">A number to multiply.</param>
		/// <returns>The product of the two parameters.</returns>
		/// <exception cref="Example1Library.NotFoundException">Thrown if the product of the two numbers are not found in the database.</exception>
		public static int GetValue(int number1, int number2)
		{
			MultiplicationTableTableAdapter ta = new MultiplicationTableTableAdapter();
			DataTable dt = ta.GetResult(number1, number2);
			if (dt.Rows.Count == 0) { throw new NotFoundException(String.Format("No result found for {0} x {1}", number1, number2)); }
			return (int)dt.Rows[0]["Outcome"];
		}
	}
}
