using System;
using System.Reflection;
using System.Xml;

namespace SqlFixture
{
	public class ExpectedObject : IExpected
	{
		string _type;

		#region Constructors & Initialization
		public ExpectedObject(string typeName)
		{
			_type = typeName;
		}

		public ExpectedObject(XmlElement xml)
		{
			_type = xml.HasAttribute("type") ? xml.GetAttribute("type") : null;
		}
		#endregion

		#region Tests
		public bool IsExpected(object obj)
		{
			Type T = Type.GetType(_type);
			return (T.IsInstanceOfType(obj));
		}

		public T GetValue<T>()
		{
			throw new NotImplementedException();
		}
		#endregion
	}
}
