using System;
using System.Collections.Generic;
using System.Text;

namespace SqlFixture
{
	public class ExpectedStringValue : IExpected
	{
		object _value;
		

		#region Constructors & Initialization
		public ExpectedStringValue(string value)
		{
			_value = value;
		}

		public ExpectedStringValue(string value, string typeName)
		{
			_value = GetValue(typeName, value);
		}

		protected object GetValue(string typeName, string value)
		{
			switch (typeName.ToLower())
			{
				case "byte":
					return Byte.Parse(value);

				case "sbyte":
					return SByte.Parse(value);

				case "int":
					return int.Parse(value);

				case "int16":
					return Int16.Parse(value);

				case "int32":
					return Int32.Parse(value);

				case "int64":
					return Int64.Parse(value);

				case "uint16":
					return UInt16.Parse(value);

				case "uint32":
					return UInt32.Parse(value);

				case "uint64":
					return UInt64.Parse(value);

				case "single":
					return Single.Parse(value);

				case "double":
					return Double.Parse(value);

				case "boolean":
					return Boolean.Parse(value);

				case "char":
					return Char.Parse(value);

				case "decimal":
					return Decimal.Parse(value);

				case "string":
					return value;

				case "datetime":
					return DateTime.Parse(value);

				default:
					return value.ToString();
			}
		}
		#endregion

		#region Tests
		public bool IsExpected(object obj)
		{
			return obj.Equals(_value);
		}

		public T GetValue<T>()
		{
			return (_value is T) ? (T)_value : default(T);
		}
		#endregion

	}
}
