using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;

namespace SqlFixture
{
	public class SqlFile
	{
		protected string _key;
		protected string _filename;
		protected string _contents = null;

		#region Static Methods & Properties
		public static NameValueCollection Configuration
		{
			get
			{
				NameValueCollection col = ConfigurationManager.GetSection("SqlFixture/SqlFiles") as NameValueCollection;
				if (col == null) { throw new ConfigurationErrorsException("SqlFixture / SqlFiles configuration section not found."); }
				return col;
			}
		}
		#endregion

		#region Properties
		public string Filename
		{
			get { return _filename; }
		}

		public string Contents
		{
			get
			{
				if (String.IsNullOrEmpty(_contents))
				{
					FileStream fs = new FileStream(_filename, FileMode.Open, FileAccess.Read);
					StreamReader sr = new StreamReader(fs);
					_contents = sr.ReadToEnd();
					sr.Close();
				}
				return _contents;
			}
		}
		#endregion

		#region Constructors & Initialization
		public SqlFile(string key)
		{
			_key = key;
			string filePath = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
			filePath = Regex.Replace(filePath, @"^[a-zA-Z0-9]+:\\", "");
			_filename = Path.Combine(filePath, Configuration[key]);
		}
		#endregion
	}
}
